//Phoenix 6 License information:
//Not Commercial use defined by QPL Open Source License.
//Contact PhoenixFund for Commercial License. Derivative works must also be QPL.
//Unless alternatively licensed by copyright holder, no commercial derivative works may exist.
//+------------------------------------------------------------------+
#property copyright "Copyright PhoenixFund under QPL License. www.bestforextools.com/pf/"

//************* User Variables ******************//
//System Changes
extern bool       EnableLogging              = false;
extern bool       EnableSignalDebug          = false;

//Profit management
bool              staticTPOn                 = true;
int               AcceptSlip                 = 3;
extern int        staticTP                   = 48;
//extern double adjustDynTP= 0.8;

//Loss management
bool              staticSLOn                 = true;
extern int        staticSL                   = 90;
//extern double adjustDynSL= 0.8;
//TODO Warn at Consec loss
//TODO Quit at Consec loss

//Trade management
extern int        maxtrades                  = 1;
extern int        SignalsConsec              = 20;   
extern bool       SignalQuitOnBlank          = false; 
extern string     U_Trade_CURRENCY           = "USDCHF";
extern string     U_Trade_PERIOD             = "M15";

extern string     C_Function_Y               = "====== U_MoneyManagement decreases lotsize in a losing streak =====";
extern bool       U_MoneyManage              = true; //Money management for lot sizing
extern double     U_Lots                     = 1;        //Money management will override setting
extern double     U_MaxRisk                  = 0.05;     
extern int        U_DecreaseFactor           = 0;    //6 digit number, 2 digits per subsequent loss 805010= 80% 50% 10%
//Daraknor Add 5.7.1 contrib Dmitry_CH, modified version of min/max settings with new style.
//Recommend changing U_MinLot based on your minimum broker value. 
extern double	  U_MinLot		     = 0.01;	 //Set to be micro safe by default, maybe this should change
extern double	  U_MaxLot		     = 99.0;	 //Set to previous max value by default
int             decimalPlaces                 = 1; //TODO more

//ExitSignal
extern bool ExitManagedOn = false;
extern bool exitParaTSOn = false;
extern double exitParAccel = 0.2;
extern int staticTS =20;

//Lot management
extern bool splitTradeOn = false;
extern int splitTrade1 = 50;
extern int splitTrade2 = 60;
extern int splitTrade3 = 70;
extern int splitTrade4 = 80;
extern int splitTrade5 = 90;
extern int splitTrade6 = 100;

extern string     C_SignalA                  = "====== Signals Enabled ============================";
extern int        signalsRequired            = 3;     //Needs to be <= # of Entry Signals
extern bool       EntrySignal1On             = true;
extern bool       EntrySignal2On             = true;
extern bool       EntrySignal3On             = true;
extern bool       EntrySignal4On             = false;
bool              EntryFilter1On             = true;
bool              EntryFilter2On             = false;
bool              EntryFilter3On             = false;
bool              EntryFilter4On             = false;
extern string     C_Signal1                  = "====== Signal 1 ===================================";
extern double     P_Percent                  = 0.0025;
extern int        P_EnvelopePeriod           = 18;

extern string     C_Signal2                  = "====== Signal 2 ==================================";
extern int        P_SMAPeriod                = 8;
extern int        P_SMA2Bars                 = 10;

extern string     C_Signal3                  = "====== Signal 3 ==================================";
extern int        P_OSMAFast                 = 17;
extern int        P_OSMASlow                 = 23;
extern double     P_OSMASignal               = 5;

extern string     C_Filter1                  = "====== Filter 1 ==================================";
extern int        P_Fast_Period              = 25;
int        P_Fast_Price               = PRICE_OPEN;
extern int        P_Slow_Period              = 37;
int        P_Slow_Price               = PRICE_OPEN;
extern double     P_DVBuySell                = 0.00031;
extern double     P_DVStayOut                = 0.044;

//******************* Global Variables ***************//
int MagicNumSet1 = 101010;
int maxMagic = 0; //Set size of magic numbers used
bool Chain2EntryOn = false;
bool W_GreenLight=true;
string W_Trade_PERIOD;
int nDaysSince1970 = 0;
int LogHandle = -1;
int BuySignal, SellSignal;

void init()
{ //Startup Functions, only called once.
  if(Symbol() != U_Trade_CURRENCY){
    Alert("These settings are designed for "+U_Trade_CURRENCY+
      " only! Change chart or update U_Trade_CURRENCY");
    W_GreenLight=false;
  }
  switch(Period())
  {
    case 1:
      W_Trade_PERIOD="M1";
      break;
    case 5:
      W_Trade_PERIOD="M5";
      break;
    case 15:
      W_Trade_PERIOD="M15";
      break;  
    case 30:
      W_Trade_PERIOD="M30";
      break;
    case 60:
      W_Trade_PERIOD="H1";
      break;      
    case 2400:
      W_Trade_PERIOD="H4";
      break;
    case 1440:
      W_Trade_PERIOD="D1";
      break;
    case 10080:
      W_Trade_PERIOD="D1";
      break;
    case 43200:
      W_Trade_PERIOD="D1";
      break;
    default:
      Alert("Your timeframe "+Period()+" was not detected.");
      W_Trade_PERIOD="";
   }
  if(U_Trade_PERIOD != W_Trade_PERIOD){
    Alert("These settings are designed for "+U_Trade_PERIOD+
      " only! Change chart or update U_Trade_PERIOD");
    W_GreenLight=false;
  }   
  //Initial Settings:
  //TODO starting balance for complex money management.
}
void start()
{
if(W_GreenLight!= true) return(0);
OpenLog("MyLog.txt");
int openticket, limitticket, stopticket;
bool buyposition, sellposition, limitposition, stopposition;
//*************** Detect open trades *********************//
for (int cticket = 0; cticket < OrdersTotal(); cticket++) { //Detect open trades
  if (OrderSelect(cticket, SELECT_BY_POS) == false)
    continue;
  if (OrderSymbol() != Symbol())
    continue;

//Log("O:"+OrderType()+ " M:"+OrderMagicNumber());
if (OrderMagicNumber() >= MagicNumSet1 && OrderMagicNumber() <= MagicNumSet1 + maxMagic) {
if (OrderType() == 0) {
buyposition = true;
openticket = OrderTicket(); 
//TODO this only works with one trade of each type open at a time. 
//Can turn this into an array, or into a data dependent check rather than boolean. 
//Not Worried at the moment because phoenix doesn't use the data at all right now.
//TODO Need if ticket!=0 as call
// Log("OP_BUY "+OrderType());
}
if (OrderType() == 1) {
openticket = OrderTicket();
sellposition = true;
// Log("OP_SELL"+OrderType());
}
if (OrderType() == 2) {
limitticket = OrderTicket();
limitposition = true;
// Log("OP_BUYLIMIT "+OrderType());
}
if (OrderType() == 3) {
limitticket = OrderTicket();
limitposition = true;
// Log("OP_SELLLIMIT "+OrderType());
}
if (OrderType() == 4) {
stopticket = OrderTicket();
stopposition = true;
// Log("OP_BUYSTOP "+OrderType());
}
if (OrderType() == 5) {
stopticket = OrderTicket();
stopposition = true;
// Log("OP_SELLSTOP"+OrderType());
}
}
}
//*************** Exit strategies **************************//
if (ExitManagedOn) {
//Check for exit strategy allowed by Magic#
//Check if exit strategy is currently in force
//TODO Set delayed TS or delayed SL values by Magic#
//TODO only works on one trade/ticket :(
   if (exitParaTSOn) trailingStop(openticket,exitParaTS());
   //TODO test for other exit strategies
   else trailingStop(openticket,staticTS);
//BreakEven SL @target
//StealthExit
}

//************* Weird tactics + Finish main loop ***************//
//Summarize open trades: Delayed Chained entry
//TODO Detect & Summarize newly closed trades, detect profit levels for MM
if (maxtrades > OrdersTotal())
  EnterNewTrade();
LogFlush();
return (0);
} //End Start() 

//***************** Exit Strategy Functions ********************//
void trailingStop (int ticket, int tsvalue)
{ 
  int delayedTS=0;  //TODO use delayed TS value from exit strategy area
  if(OrderSelect(ticket, SELECT_BY_TICKET) == true)
  { //If ticket was found
    double slvalue;
    if (OrderType() == OP_BUY) 
    {
      slvalue=Bid-(Point*tsvalue);
      if (OrderStopLoss() < slvalue && OrderOpenPrice()+(Point*tsvalue)>Bid+delayedTS*Point)
      {  // Log("OrderSL:" +OrderStopLoss()+ " slvalue:"+ slvalue);
        if (!ModifySL(slvalue,ticket)) LogError();
      }
    } else {
      if (OrderType() == OP_SELL) 
      {
        slvalue=Ask+(Point*tsvalue);
        if (OrderStopLoss() > slvalue && OrderOpenPrice()-(Point*tsvalue)<Ask-delayedTS*Point)
        {  // Log("OrderSL:" +OrderStopLoss()+ " slvalue:"+ slvalue);
          if (!ModifySL(slvalue,ticket)) LogError();
        }
      }
    }
  }
}
bool ModifySL(double sl, int ticket)
{
  Log(ticket+" "+OrderOpenPrice()+" "+sl+" "+OrderTakeProfit());
  int results=OrderModify(ticket,OrderOpenPrice(),sl,OrderTakeProfit(),0,Red);
  if(results!=(-1)) return(true);
  else return(false);
}
int exitParaTS()
{ //Using M1 iSAR because this is used for trailing stops and it needs to react quickly.
  return(NormalizeDouble(iSAR(NULL,PERIOD_M1,exitParAccel,0.2,0),1));
}
//********************* Check for New Trade *******************//
void EnterNewTrade()
{ //Check singals and conditions to enter new trade
int signal;
bool disableBuy=false;
bool disableSell=false;
if (EntryFilter1On)
  if (EntryFilter1() == false) {disableBuy=true; disableSell=true;}
if (EntryFilter2On)
  if (EntryFilter2() == false) {disableBuy=true; disableSell=true;}
if (EntryFilter3On)
  if (EntryFilter3() == false) disableBuy=true;
if (EntryFilter4On)
  if (EntryFilter4() == false) disableSell=true;

if (!disableBuy && !disableSell){   //if we can't trade, don't do unnecessary math
   if (EntrySignal1On)
   {
      signal += EntrySignal1();
      Debug("Signal1 sum: "+signal);
   }
   if (EntrySignal2On)
   {
      signal += EntrySignal2();
      Debug("Signal2 sum: "+signal);
   }
   if (EntrySignal3On)
   {
      signal += EntrySignal3();
      Debug("Signal3 sum: "+signal);
   }   
   if (EntrySignal4On)
   {
      signal += EntrySignal4();
      Debug("Signal4 sum: "+signal);
   }
}
/*int lots = GetLotSize();
Log("Lots calcuated as "+lots);
lots=lots*EntryConfirmation1();     //increase or decrease trade size by EntryConfirmation
if (lots>U_MaxLot) lots=U_MaxLot;
if (lots<U_MinLot) lots=U_MinLot;
*/
if(!disableBuy) if(signal >= signalsRequired) 
   { //Check for Buy
      BuySignal++;
      SellSignal=0;
   } else if(!disableSell) //Conserve Execution, Check for Sell
      if(signal <= (-1)*signalsRequired)
      {
        BuySignal=0;
        SellSignal++;        
      } //If neither buy nor sell signal..
      else if(SignalQuitOnBlank)
      {
        BuySignal=0;
        SellSignal=0; 
      }
//it looks funny, but it above statement is properly closed.

if(SignalsConsec<=BuySignal) { OrderNewBuy(GetLotSize()*EntryConfirmation1()); BuySignal=0;} 
else if(SignalsConsec<=SellSignal) { OrderNewSell(GetLotSize()*EntryConfirmation1()); SellSignal=0;}
}
//*********************Trade Management *****************//
double GetLotSize()
{ //Old Style Lot Management. TODO replace with contributed code. Pcontour rewrote.
    if(!U_MoneyManage) return(U_Lots);
    double lot          =U_Lots;
    int    orders       =HistoryTotal();
    int    i            =0;
    int    trades       =0;
    int    wins         =0;
    int    losses       =0;
    int    decimalPlaces=1;
    if(MarketInfo(Symbol(),MODE_LOTSTEP)==1) decimalPlaces=0; //Dmitry_CH Add 5.7.1
    lot=NormalizeDouble(AccountFreeMargin()*U_MaxRisk/1000.0,decimalPlaces);
    if(U_DecreaseFactor>256)
    { //need to check for a real value
       i            =orders-1;
       trades       =0;
       wins         =0;
       losses       =0;
       while (trades< 3 && i > 0) 
       {
          if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) 
          { 
            Log("Error in history!"); 
            break; 
          }
          if(OrderSymbol()==Symbol() && OrderType()<=OP_SELL) 
          {
              trades++;
              if(OrderProfit()<0) losses++;
              if(OrderProfit()>0) wins++;
          }  
          i--;
       }
       if (U_DecreaseFactor > 999999)
       {
           Log("U_DecreaseFactor too large.  Changed to 802000");
           U_DecreaseFactor = 802000;
       }
       int Loss1_Percentage =  U_DecreaseFactor * 0.0001;
       int Loss2_Percentage = (U_DecreaseFactor - 10000 * Loss1_Percentage) * 0.01;
       int Loss3_Percentage = (U_DecreaseFactor - 10000 * Loss1_Percentage
                                                -   100 * Loss2_Percentage);
                                                
       Log("Breakit "+Loss1_Percentage+" "+Loss2_Percentage+" "+Loss3_Percentage) ;                                               
//     if (losses==0){ lot=lot*100             *0.01;   }  //This line is just documentation
       if (losses==1){ lot=lot*Loss1_Percentage*0.01;   }
       if (losses==2){ lot=lot*Loss2_Percentage*0.01;   }
       if (losses>=3){ lot=lot*Loss3_Percentage*0.01;   }
       Log("  losses "+losses+"  lot "+lot);
      }
    if(lot<U_MinLot) { lot=U_MinLot; Log("lots switched to min "+lot); }
    if(lot>U_MaxLot) { lot=U_MaxLot; Log("lots switched to max "+lot); }
    lot = NormalizeDouble(lot,decimalPlaces); 
    return(lot);
}
double EntryConfirmation1()
{ //TODO we need to collect data on "trades that win most often" based on signals.
return(1.0);
}

void OrderNewBuy(double lots)
{ //Trade TP+SL Signals
  double calcTP, calcSL;
  if (staticTPOn) calcTP = staticTP;
  else calcTP = staticTP; //TODO add dynamic tp/sl
  if (staticSLOn) calcSL = staticSL;
  else calcSL = staticSL; //TODO add dynamic tp/sl
  if (calcTP == 0 || calcSL == 0)
  {
    Log("Missing TP or SL. TP:" + calcTP + " SL:" + calcSL);
  } else {
    if (splitTradeOn) splitTrades(calcTP, calcSL, lots, 0);
    else fireTrade(calcTP, calcSL, lots, 0);
  }
  if(Chain2EntryOn){ Chain2Entry(calcTP, calcSL, lots,4,calcSL*(-1)); }//Sell limit
}
void OrderNewSell(double lots)
{ //Trade TP+SL Signals
double calcTP, calcSL;
  if (staticTPOn) calcTP = staticTP;
  else calcTP = staticTP; //todo add dynamic tp/sl
  if (staticSLOn) calcSL = staticSL;
  else calcSL = staticSL;//todo add dynamic tp/sl
  if (calcTP == 0 || calcSL == 0)
  {
    Log("Missing TP or SL. TP:" + calcTP + " SL:" + calcSL);
  } else {
    if (splitTradeOn) splitTrades(calcTP, calcSL, lots, 1);
    else fireTrade(calcTP, calcSL, lots, 1);
  } 
  if(Chain2EntryOn){ Chain2Entry(calcTP, calcSL, lots,3,calcSL*(-1));} //Buy limit
}

void splitTrades(int calcTP, int calcSL, double lots, int order)
{
int splitcount = 0; //so much easier to do this pedantically than recursively.
if (splitTrade1 != 0) splitcount++;
if (splitTrade2 != 0) splitcount++;
if (splitTrade3 != 0) splitcount++;
if (splitTrade4 != 0) splitcount++;
if (splitTrade5 != 0) splitcount++;
if (splitTrade6 != 0) splitcount++;
double splitlots = NormalizeDouble(lots / splitcount, decimalPlaces);
fireTrade(calcTP * splitTrade1 / 100, calcSL, splitlots, order, 1);
fireTrade(calcTP * splitTrade2 / 100, calcSL, splitlots, order, 2);
fireTrade(calcTP * splitTrade3 / 100, calcSL, splitlots, order, 3);
fireTrade(calcTP * splitTrade4 / 100, calcSL, splitlots, order, 4);
fireTrade(calcTP * splitTrade5 / 100, calcSL, splitlots, order, 5);
fireTrade(calcTP * splitTrade6 / 100, calcSL, splitlots, order, 6);
}

int priceoffset=0; //TODO This function is temporarily disabled. priceoffset is a global variable.
void Chain2Entry(int TP, int SL, double lot, int order,int offset)
{//make system reverse TP and SL values and put pending trade opposite direction
  int priceoffset; //This function is temporarily disabled. priceoffset is a global variable.
  priceoffset=offset;
  fireTrade(TP,SL,lot,order);
  priceoffset=0;
}

int fireTrade(int TP, int SL, double lot, int order, int incMagic = 0)
{ //Execute Trades
  double price;
  color arrow;
  int ticket;
  string tradecomment;
  if (incMagic==0) tradecomment="Primary Order"; 
  else tradecomment="Order is "+incMagic;
  if (order %2==0) 
  { //if number is even
    price = Ask+priceoffset;
    arrow = Blue;
  }
  if (order %2==1) 
  { //if number is odd
    price = Bid-priceoffset;
    SL = -SL;
    TP = -TP;
    arrow = Red;
  }
//ticket = OrderSend(Symbol(), order, lot, price, AcceptSlip,price-SL*Point,price+TP*Point, "",MagicNumSet1 + incMagic, 0, arrow);
//ticket = OrderSend(Symbol(),OP_BUY,1,Ask,3,Ask-25*Point,Ask+25*Point,"My order #2",16384,0,Green);
//buy works ticket = OrderSend(Symbol(),order,1,price,AcceptSlip,price-25*Point,price+25*Point,"",MagicNumSet1 + incMagic, 0, arrow);
ticket = OrderSend(Symbol(),order,lot,price,AcceptSlip,price-SL*Point,price+TP*Point,"",MagicNumSet1 + incMagic, 0, arrow);
  if (ticket != -1){
    Log("Success:"+ticket+" "+Symbol()+" order:"+order+" lot:"+lot+" price:"+price+" SL:"+(price-SL*Point)+" TP:"+(price+TP*Point));
    return (ticket); //TODO use ticket number somehow
  } else {
    int error=GetLastError();
    Log("Error:"+error+" "+Symbol()+" order:"+order+" lot:"+lot+" price:"+price+" SL:"+(price-SL*Point)+" TP:"+(price+TP*Point));
/*    if(error==135 || error==136 || error==138 || error==129 || error==130)
    { //Handle a few errors we know about, usually price movement. TODO make this configurable.
      RefreshRates();
      ticket=OrderSend(Symbol(), order, lot, price, AcceptSlip,
            price - SL * Point,price + TP * Point, '',
            MagicNumSet1 + incMagic,0, arrow);
      if (ticket != -1) return (ticket); //TODO use ticket number somehow
      else Log("Error: Order send failed twice. Quitting."+ GetLastError());
    } */
  }
}

//********************** SIGNALS *********************//
int EntrySignal1()
{
   int value=0;
   double HighEnvelope1 = iEnvelopes(NULL,0,P_EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,P_Percent,MODE_UPPER,1);
   double LowEnvelope1  = iEnvelopes(NULL,0,P_EnvelopePeriod,MODE_SMA,0,PRICE_CLOSE,P_Percent,MODE_LOWER,1);
   double CloseBar1     = iClose(NULL,0,1);
   if(CloseBar1 > HighEnvelope1) {value=-1;}
   if(CloseBar1 < LowEnvelope1)  {value=1;}
   Debug("Signal 1 HighEnv:"+HighEnvelope1+" LowEnv:"+LowEnvelope1+" Close:"+CloseBar1);
   return (value);
}

int EntrySignal2()
{
   int value=0;
   double SMA1=iMA(NULL,0,P_SMAPeriod,0,MODE_SMA,PRICE_CLOSE,1);
   double SMA2=iMA(NULL,0,P_SMAPeriod,0,MODE_SMA,PRICE_CLOSE,P_SMA2Bars);
   if (SMA2-SMA1 >0) value=1;
   else value=-1;
   Debug("Signal2 SMA Diff:"+(SMA2-SMA1)+" SMA2:"+SMA2+" SMA1:"+SMA1);
   return (value);
}

int EntrySignal3()
{
   int value=0;
   double OsMABar2=iOsMA(NULL,0,P_OSMAFast,P_OSMASlow,P_OSMASignal,PRICE_CLOSE,2);
   double OsMABar1=iOsMA(NULL,0,P_OSMAFast,P_OSMASlow,P_OSMASignal,PRICE_CLOSE,1);
   if (OsMABar2-OsMABar1 >0) value=1;
   else value=-1;
   Debug("Signal3 OsMA Diff:"+(OsMABar2-OsMABar1)+" OsMABar2:"+OsMABar2+" OsMABar1:"+OsMABar1);
   return (value); 
}
int EntrySignal4(){} //TODO placeholder for another entry signal

int EntryFilter1(){
   bool value=false;
   double diverge;
   diverge = Z_S4_Divergence(P_Fast_Period, P_Slow_Period, P_Fast_Price, P_Slow_Price,0);
   if(diverge >= P_DVBuySell && diverge <= P_DVStayOut) 
      value=true;
   Debug("EntryFilter DVStayOut:"+P_DVStayOut+" Diverge:"+diverge+" DVBuySell:"+P_DVBuySell);
   return (value);  
}
bool EntryFilter2()
{ //TODO Time Expiry
  return (true);
}
bool EntryFilter3()
{  //TODO if BUY Signal, check buy trend
}
bool EntryFilter4()
{  //TODO if SELL Signal, check sell trend
}

//********************** Signal Functions ******************//
double Z_S4_Divergence(int F_Period, int S_Period, int F_Price, int S_Price, int mypos)
  {
    int i;
    double maF1, maF2, maS1, maS2;

    maF2 = iMA(Symbol(), 0, F_Period, 0, MODE_SMA, F_Price, mypos + 1);
    maS2 = iMA(Symbol(), 0, S_Period, 0, MODE_SMA, S_Price, mypos + 1);

    return(maF2-maS2);
  }

//*********************** LOGGING **************************//
void OpenLog(string strName)
{
if (!EnableLogging && !EnableSignalDebug)
return;
if (TimeCurrent() / (60 * 60 * 24) > nDaysSince1970 || LogHandle <= 0) 
{ //Pick a new filename and open it.
  if (LogHandle > 0) FileClose(LogHandle);
  string strMonthPad = "";
  string strDayPad = "";
  if (Month() < 10) strMonthPad = "0";
  if (Day() < 10) strDayPad = "0";
  string strFilename =StringConcatenate(strName, "_", Year(), 
      strMonthPad, Month(),strDayPad, Day(), "_log.txt");
  LogHandle =FileOpen(strFilename, FILE_CSV | FILE_READ | FILE_WRITE);
  nDaysSince1970 = TimeCurrent() / (60 * 60 * 24);
}
FileFlush(LogHandle);
FileSeek(LogHandle, 0, SEEK_END);
}

void Log(string msg)
{
   if (!EnableLogging) return;
   if (LogHandle <= 0) return;
   msg = TimeToStr(TimeCurrent(),
      TIME_DATE | TIME_MINUTES | TIME_SECONDS) + " " + msg;
   FileWrite(LogHandle, msg);
}
void Debug(string msg)
{ //Signal Debugging, rarely called
   if (!EnableSignalDebug) return;
   if (LogHandle <= 0) return;
   msg = TimeToStr(TimeCurrent(),
      TIME_DATE | TIME_MINUTES | TIME_SECONDS) + " " + msg;
   FileWrite(LogHandle, msg);
}

void LogFlush()
{if (!EnableLogging)
return;
FileFlush(LogHandle);
}

void LogError()
{if (!EnableLogging)
return;
Log("Error:"+ GetLastError()+" OrderType:"+OrderType()+" Ticket:"+OrderTicket());
}
//End Of File